// Author: Marek Handl
// Date: October 18, 2008
// CTU, FEE, X36PAA
// Knapsack problem - brute force and heuristic solution comparison
// takes in already computed solutions and compares them

#include <string>
#include <fstream>
#include <iostream>
using namespace std;

int main(int argc, char* argv[])
{
  ifstream finOptimal, finHeuristic;
  float error = 0, maxError = 0, currentError;
  string lineOptimal, lineHeuristic;
  int instancesCount = 0, priceOptimal, priceHeuristic, dummy;
  
  if (argc < 3) {
    cout << "Usage: knapsackCompare.exe input_optimal input_heuristic" << endl;
    return 0;
  }
    
  try {
	  finOptimal.open(argv[1]);
	  finHeuristic.open(argv[2]);
	  
	  while (getline(finOptimal, lineOptimal)) {
		getline(finHeuristic, lineHeuristic);
		sscanf_s(lineOptimal.c_str(), "%d %d %d", &dummy, &dummy, &priceOptimal);
		sscanf_s(lineHeuristic.c_str(), "%d %d %d", &dummy, &dummy, &priceHeuristic);
		currentError = (float)(priceOptimal - priceHeuristic) / (float)priceOptimal;
		error += currentError;
		maxError = (currentError > maxError ? currentError : maxError);
		++instancesCount;
	  }
	  
	  finOptimal.close();
	  finHeuristic.close();
	  
	  cout << "Average error: " << error*100/(float)instancesCount << "%" << endl;
	  cout << "Maximum error: " << maxError*100 << "%" << endl;
  }
  catch(...) {
	  cout << "File error" << endl;
	  exit(1);
  }
}
